"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/asyncToGenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/defineProperty"));

require("codemirror/mode/markdown/markdown");

var _react = _interopRequireWildcard(require("react"));

var SERVER_RENDERED = typeof navigator === 'undefined' || global.PREVENT_CODEMIRROR_RENDER === true;
var cm;

if (!SERVER_RENDERED) {
  // tslint:disable-next-line: no-var-requires
  cm = require('codemirror');
}

var ReactCodeMirror =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(ReactCodeMirror, _Component);

  // public editor!: Doc | Editor | EditorFromTextArea | Editor;
  function ReactCodeMirror(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, ReactCodeMirror);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(ReactCodeMirror).call(this, props));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "textarea", void 0);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "editor", void 0);
    return _this;
  }

  (0, _createClass2["default"])(ReactCodeMirror, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react["default"].createElement("textarea", {
        ref: function ref(instance) {
          return _this2.textarea = instance;
        }
      });
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      if (SERVER_RENDERED) {
        return;
      }

      if (this.props.editorWillMount) {
        this.props.editorWillMount();
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      if (SERVER_RENDERED) {
        return;
      }

      var options = this.props.options;

      if (this.props.defineMode) {
        if (this.props.defineMode.name && this.props.defineMode.fn) {
          cm.defineMode(this.props.defineMode.name, this.props.defineMode.fn);
        }
      }

      var editorOption = (0, _objectSpread2["default"])({
        tabSize: 2,
        lineNumbers: true
      }, options, {
        mode: 'markdown'
      }); // 生成codemirror实例

      this.editor = cm.fromTextArea(this.textarea, editorOption);
      this.renderCodeMirror(this.props);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function () {
      var _componentWillReceiveProps = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee(nextPros) {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                this.renderCodeMirror(nextPros);

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function componentWillReceiveProps(_x) {
        return _componentWillReceiveProps.apply(this, arguments);
      }

      return componentWillReceiveProps;
    }() // 将props中所有的事件处理函数映射并保存

  }, {
    key: "getEventHandleFromProps",
    value: function getEventHandleFromProps() {
      var propNames = Object.keys(this.props);
      var eventHandle = propNames.filter(function (prop) {
        return /^on+/.test(prop);
      });
      var eventDict = {};
      eventHandle.forEach(function (ele) {
        eventDict[ele] = ele.replace(/^on[A-Z]/g, function (s) {
          return s.slice(2).toLowerCase();
        });
      });
      return eventDict;
    }
  }, {
    key: "renderCodeMirror",
    value: function renderCodeMirror(props) {
      var _this3 = this;

      var value = props.value,
          width = props.width,
          height = props.height; // 获取CodeMirror用于获取其中的一些常量
      // 事件处理映射

      var eventDict = this.getEventHandleFromProps();
      Object.keys(eventDict).forEach(function (event) {
        var handle = _this3.props[event];

        _this3.editor.on(eventDict[event], handle);
      }); // Init value

      this.editor.setValue(value || ''); // this.editor.setOption(name, editorOption.mode);

      if (width || height) {
        // Setting size
        this.editor.setSize(width, height);
      }
    }
  }]);
  return ReactCodeMirror;
}(_react.Component);

exports["default"] = ReactCodeMirror;
(0, _defineProperty2["default"])(ReactCodeMirror, "defaultProps", {
  height: '100%',
  options: {
    lineNumbers: true,
    mode: 'markdown',
    tabSize: 2
  },
  value: '',
  width: '100%'
});
//# sourceMappingURL=index.js.map