(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "@babel/runtime/helpers/extends", "@babel/runtime/helpers/objectWithoutProperties", "@babel/runtime/helpers/classCallCheck", "@babel/runtime/helpers/createClass", "@babel/runtime/helpers/possibleConstructorReturn", "@babel/runtime/helpers/getPrototypeOf", "@babel/runtime/helpers/assertThisInitialized", "@babel/runtime/helpers/inherits", "@babel/runtime/helpers/defineProperty", "classnames", "react", "./components/CodeMirror", "./components/PreviewMarkdown", "./components/ToolBar", "./index.css"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("@babel/runtime/helpers/extends"), require("@babel/runtime/helpers/objectWithoutProperties"), require("@babel/runtime/helpers/classCallCheck"), require("@babel/runtime/helpers/createClass"), require("@babel/runtime/helpers/possibleConstructorReturn"), require("@babel/runtime/helpers/getPrototypeOf"), require("@babel/runtime/helpers/assertThisInitialized"), require("@babel/runtime/helpers/inherits"), require("@babel/runtime/helpers/defineProperty"), require("classnames"), require("react"), require("./components/CodeMirror"), require("./components/PreviewMarkdown"), require("./components/ToolBar"), require("./index.css"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global._extends, global.objectWithoutProperties, global.classCallCheck, global.createClass, global.possibleConstructorReturn, global.getPrototypeOf, global.assertThisInitialized, global.inherits, global.defineProperty, global.classnames, global.react, global.CodeMirror, global.PreviewMarkdown, global.ToolBar, global.index);
    global.index = mod.exports;
  }
})(this, function (_exports, _extends2, _objectWithoutProperties2, _classCallCheck2, _createClass2, _possibleConstructorReturn2, _getPrototypeOf2, _assertThisInitialized2, _inherits2, _defineProperty2, _classnames, React, _CodeMirror, _PreviewMarkdown, _ToolBar, _index) {
  "use strict";

  var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

  var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports["default"] = void 0;
  _extends2 = _interopRequireDefault(_extends2);
  _objectWithoutProperties2 = _interopRequireDefault(_objectWithoutProperties2);
  _classCallCheck2 = _interopRequireDefault(_classCallCheck2);
  _createClass2 = _interopRequireDefault(_createClass2);
  _possibleConstructorReturn2 = _interopRequireDefault(_possibleConstructorReturn2);
  _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf2);
  _assertThisInitialized2 = _interopRequireDefault(_assertThisInitialized2);
  _inherits2 = _interopRequireDefault(_inherits2);
  _defineProperty2 = _interopRequireDefault(_defineProperty2);
  _classnames = _interopRequireDefault(_classnames);
  React = _interopRequireWildcard(React);
  _CodeMirror = _interopRequireDefault(_CodeMirror);
  _PreviewMarkdown = _interopRequireDefault(_PreviewMarkdown);
  _ToolBar = _interopRequireDefault(_ToolBar);

  var MarkdownEditor =
  /*#__PURE__*/
  function (_React$PureComponent) {
    (0, _inherits2["default"])(MarkdownEditor, _React$PureComponent);

    function MarkdownEditor(props) {
      var _this;

      (0, _classCallCheck2["default"])(this, MarkdownEditor);
      _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(MarkdownEditor).call(this, props));
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "preview", void 0);
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "CodeMirror", void 0);
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getInstance", function (editor) {
        if (editor) {
          _this.CodeMirror = editor;
        }
      });
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onChange", function (editor, data, value) {
        var _ref = _this.props,
            onChange = _ref.onChange;

        if (onChange) {
          if (_this.preview) {
            _this.preview.updateSource(editor.getValue());
          }

          onChange(editor, data, value);
        }
      });
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onClick", function (type) {
        if (type === 'preview') {
          _this.previewMarkdown();

          return;
        }

        var selection = _this.CodeMirror.editor.getSelection();

        var pos = _this.CodeMirror.editor.getCursor();

        var value = ''; // 'header', 'strike', 'underline', 'olist', 'ulist', 'todo', 'link', 'image', 'quote', 'preview'

        if (type === 'bold') {
          value = selection ? "**".concat(selection, "**") : "****";
          pos.ch = selection ? pos.ch : pos.ch + 2;
        }

        if (type === 'italic') {
          value = selection ? "*".concat(selection, "*") : "**";
          pos.ch = selection ? pos.ch : pos.ch + 1;
        }

        if (type === 'header') {
          value = selection ? "# ".concat(selection) : '# ';
          pos.ch = selection ? pos.ch : pos.ch + 2;
        }

        if (type === 'strike') {
          value = selection ? "~~".concat(selection, "~~") : '~~~~';
          pos.ch = selection ? pos.ch : pos.ch + 2;
        }

        if (type === 'underline') {
          value = selection ? "<u>".concat(selection, "</u>") : '<u></u>';
          pos.ch = selection ? pos.ch : pos.ch + 3;
        }

        if (type === 'olist') {
          value = selection ? "- ".concat(selection) : '- ';
          pos.ch = selection ? pos.ch : pos.ch + 2;
        }

        if (type === 'ulist') {
          value = selection ? "1. ".concat(selection) : '1. ';
          pos.ch = selection ? pos.ch : pos.ch + 3;
        }

        if (type === 'todo') {
          value = selection ? "- [ ] ".concat(selection) : '- [ ] ';
          pos.ch = selection ? pos.ch : pos.ch + 6;
        }

        if (type === 'link') {
          value = '[连接说明](连接地址 "连接标题")';
        }

        if (type === 'image') {
          value = selection ? "".concat(selection, " ![](\u56FE\u7247\u5730\u5740 \"\u56FE\u7247\u63CF\u8FF0\")") : '![图片描述](图片地址 "图片描述")\n';
        }

        if (type === 'quote') {
          value = selection ? "> ".concat(selection) : '> ';
          pos.ch = selection ? pos.ch : pos.ch + 2;
        }

        _this.CodeMirror.editor.replaceSelection(value);

        _this.CodeMirror.editor.focus();

        _this.CodeMirror.editor.setCursor(pos.line, pos.ch);
      });
      _this.state = {
        preview: true
      };
      return _this;
    }

    (0, _createClass2["default"])(MarkdownEditor, [{
      key: "render",
      value: function render() {
        var _this2 = this;

        var _this$props = this.props,
            prefixCls = _this$props.prefixCls,
            className = _this$props.className,
            toolbars = _this$props.toolbars,
            onChange = _this$props.onChange,
            codemirrorProps = (0, _objectWithoutProperties2["default"])(_this$props, ["prefixCls", "className", "toolbars", "onChange"]);
        return React.createElement("div", {
          className: (0, _classnames["default"])(prefixCls, className)
        }, React.createElement(_ToolBar["default"], {
          toolbars: toolbars,
          onClick: this.onClick
        }), React.createElement("div", {
          className: (0, _classnames["default"])("".concat(prefixCls, "-content"))
        }, React.createElement(_CodeMirror["default"], (0, _extends2["default"])({
          style: {
            width: this.state.preview ? '50%' : '100%'
          },
          width: this.state.preview ? '50%' : '100%',
          ref: this.getInstance
        }, codemirrorProps, {
          onChange: this.onChange
        })), React.createElement(_PreviewMarkdown["default"], {
          ref: function ref(pmd) {
            return _this2.preview = pmd;
          },
          value: this.props.value,
          visble: this.state.preview
        })));
      }
    }, {
      key: "previewMarkdown",
      value: function previewMarkdown() {
        this.setState({
          preview: !this.state.preview
        });
      }
    }]);
    return MarkdownEditor;
  }(React.PureComponent);

  _exports["default"] = MarkdownEditor;
  (0, _defineProperty2["default"])(MarkdownEditor, "displayName", 'MarkdownEditor');
  (0, _defineProperty2["default"])(MarkdownEditor, "defaultProps", {
    onChange: function onChange() {
      return null;
    },
    prefixCls: 'md-editor',
    value: ''
  });
});
//# sourceMappingURL=index.js.map